%define		gemdir		%(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%define		gemname		zoom
%define		geminstdir	%{gemdir}/gems/%{gemname}-%{version}

%{!?ruby_sitearch:	%global	ruby_sitearch	%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")}

%define		rubyabi		1.8
%define		repoid		28211


Name:		rubygem-%{gemname}
Version:	0.4.1
Release:	7%{?dist}
Group:		Development/Languages
Summary:	Ruby binding to ZOOM

License:	LGPLv2+
URL:		http://ruby-zoom.rubyforge.org/
Source0:	http://rubyforge.org/frs/download.php/%{repoid}/%{gemname}-%{version}.gem
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	rubygem(rake)
BuildRequires:	ruby-devel

BuildRequires:	libxslt-devel
BuildRequires:	libyaz-devel
BuildRequires:	tcp_wrappers
%if 0%{?fedora} >= 7
BuildRequires:	tcp_wrappers-devel
%endif

Requires:	ruby(abi) = %{rubyabi}
Requires:	ruby(rubygems)

Provides:	rubygem(%{gemname}) = %{version}-%{release}
# Obsolete but not provide
# Obsoletes: ruby(zoom) < 0.3.0 does not obsolete ruby-zoom
Obsoletes:	ruby-zoom < 0.3.0

%description
Ruby/ZOOM provides a Ruby binding to the Z39.50 Object-Orientation 
Model (ZOOM), an abstract object-oriented programming interface 
to a subset of the services specified by the Z39.50 standard, 
also known as the international standard ISO 23950.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.


%prep
%setup -q -c
%{__gzip} -dc data.tar.gz | %{__tar} -x -f -

# Cleanup
%{__rm} -rf */CVS/
find . -type f -print0 | xargs -0 touch -r %{SOURCE0}

# Repackage to split out unneeded files
# So unpack source again
%{__mkdir} Repackage
cd Repackage
%{__gzip} -dc ../data.tar.gz | %{__tar} -x -f -
cd ..

# Permission
find . -type f -print0 | xargs -0 %{__chmod} 0644

%build
# Repackage gem
cd Repackage
%{__rm} -rf \
	sample/ \
	test/ \

rake gem
%{__mv} pkg/*.gem ..
cd ..

%install
%{__rm} -rf %{buildroot}

# 1. gem install
##
##  First install gem files under %%builddir (not %%buildroot),
##  then copy (not move) whole tree to %%buildroot.
##
##  Otherwise check-buildroot will complain for ruby
##  C extention because C extention compilation is done
##  under %%buildroot.
##  Also when we "move" whole tree (not copy) to
##  %%buildroot debuginfo.sh will complain that the sources
##  are missing.
##
%{__rm} -rf ./tmpinstdir

%{__mkdir_p} ./tmpinstdir/%{gemdir}
%{__mkdir_p} %{buildroot}%{gemdir}

# Set CFLAGS
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
gem install \
	-V \
	--local \
	--install-dir ./tmpinstdir/%{gemdir} \
	--force \
	*.gem
%{__cp} -a ./tmpinstdir/%{gemdir}/* %{buildroot}%{gemdir}/

# 2. move ruby C extention
%{__mkdir_p} %{buildroot}%{ruby_sitearch}
%{__mv} -f %{buildroot}%{geminstdir}/lib/*.so \
	%{buildroot}%{ruby_sitearch}/

# 3. Cleanups
%{__rm} -rf %{buildroot}%{geminstdir}/lib/
pushd %{buildroot}%{geminstdir}/src/
%{__rm} -f \
	*.{so,o} \
	Makefile \
	mkmf.log
popd

%check
# Net connection needed, disabling now.
exit 0
rake test

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root,-)
%{ruby_sitearch}/%{gemname}.so

%{geminstdir}/
%exclude %{geminstdir}/src/
%exclude %{geminstdir}/Rakefile

%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files doc
%defattr(-,root,root,-)
%doc sample/
%doc test/
%{geminstdir}/src/
%{geminstdir}/Rakefile

%changelog
* Sat Sep 19 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-7
- Fix permission

* Sat Jul 25 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-6
- F-12: Mass rebuild

* Tue Feb 24 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-5
- %%global-ize "nested" macro

* Mon Oct 27 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-4
- Better way to set CFLAGS and create debuginfo rpm correctly

* Wed Oct  8 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-3
- Split out unneeded files in better way

* Sat Feb  9 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp>
- Rebuild against gcc43

* Thu Dec  6 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-2.dist.2
- Rebuild against new openssl

* Wed Nov 21 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.4.1-2
- 0.4.1
- Also update URL

* Tue Nov 13 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.3.0-1
- 0.3.0, switch to gem.

* Sun Nov  4 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.2.3-1
- 0.2.3

* Wed Aug 22 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.2.2-3.dist.2
- Mass rebuild (buildID or binutils issue)

* Fri Aug  3 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.2.2-3.dist.1
- License update

* Sat Jun 16 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.2.2-3
- Rebuild (against new yaz)

* Sat Apr 28 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.2.2-2
- Add more documents

* Sat Apr 21 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.2.2-1
- Initial packaging
